#include "tycho2sp.h"
#include "loadsp.h"

typedef struct
{
 unsigned TYC1; //  TYC1
 unsigned TYC2; //  TYC2
 unsigned TYC3; //  TYC3
 char TClass; //  
 char SClass; //  
 char LClass; //  
}  TSpData;

TSpData  SpData[Tycho2SpNumOfStars];
long     Index[9537];


void LoadSpData()
{
 long i;
 TTycho2Sp star;
 unsigned long k;

 k=0;
 OpenTycho2Sp();
 for (i=0; i<Tycho2SpNumOfStars; i++)
 {
   ReadTycho2Sp(&star);
   SpData[i].TClass=star.TClass;
   SpData[i].SClass=star.SClass;
   SpData[i].LClass=star.LClass;
   SpData[i].TYC1=star.TYC1;
   SpData[i].TYC2=star.TYC2;
   SpData[i].TYC3=star.TYC3;
   if (star.TYC1>k) //     GSC
   { k=star.TYC1; //      
   Index[k-1]=i; // , .   GSC
   }
  }
 }


bool FindSpData(unsigned T1, unsigned T2, unsigned T3,
        char &TCl, char &SCl, char &LCl)
{
 long i;
 i=Index[T1-1];
 while (i<Tycho2SpNumOfStars)
 {
    if (SpData[i].TYC1>T1) break;
    if ( SpData[i].TYC2==T2 && SpData[i].TYC3==T3)
    {
     TCl=SpData[i].TClass;
     SCl=SpData[i].SClass;
     LCl=SpData[i].LClass;
     return true;
    }
    i++;
  }
 return false;
}


