#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <graphics.h>
#include <conio.h>
#include "tycho2.h"

#define Vmin  9.0 //   
#define Vmax 10.0 //  

void Aitoff(double l, double b, //    
       double &x, double &y)  //  {   }
{
  double s;
  if (l>M_PI) l=l-2*M_PI; //  l   -PI  +PI
  s=sqrt(1.0+cos(b)*cos(l/2.0)); //   4.1
  x=-2.0*cos(b)*sin(l/2.0)/s;
  y=sin(b)/s;
 }


void Screen
(double x, double y,  //   }
 int X0, int Y0, //     
 double Scale, //  -      
 int &u, int&v ) //  
{
  u=X0+floor(Scale*x+0.5);
  v=Y0-floor(Scale*y+0.5);
 }


double rad(double x) //    
{
 return x/180.0*M_PI;
}


void AitoffGrid
(int Step,       //    
 int X0, int Y0, //    
 double Scale,   //  -    
 int Gr )        //  -       
{
  int i,j;    //   for
  double l,b; //  
  double x,y; //  
  int  u,v;   //  
  char s[6];  //   
  int  h;     //   

 //   
 i=-180; //   -180 

 do { //   

  l=rad(i); //   
  j=-90;    //   

  do { //    

   //   
   b=rad(j); 	     //    
   Aitoff(l,b,x,y); //    
   Screen(x,y,X0,Y0,Scale,u,v); //    .

  //    (j=-90),    
  //   (u,v)  MoveTo,    , 
  // ""     
  //   (u,v)  LineTo.
   if (j==-90) moveto(u,v); else lineto(u,v);

   j+=5; //  5     

  } while (j<=90);

  i+=Step; //    

 } while (i<=180);

//    -  
j=-90;
 do {      //   
  b=rad(j);
  i=-180;
  do {     //    
   l=rad(i);
   Aitoff(l,b,x,y);
   Screen(x,y,X0,Y0,Scale,u,v);
   if (i==-180) moveto(u,v); else lineto(u,v);
   i=i+5;
  } while (i<=180);
  j+=Step;
 } while (j<=90);
 //    (   ..)
 settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 settextjustify(LEFT_TEXT,BOTTOM_TEXT);


 //    
 i=-180;
 do{

  //     
  l=rad(i);
  Aitoff(l,0,x,y);
  Screen(x,y,X0,Y0,Scale,u,v);

  //  Gr ,    ,   - 
  if (Gr) h=i;
	else { h=i/15; if (h<0) h+=24;
	     };

  itoa(h,s,10); //   h    
  outtextxy(u+5,v-5,s); //   

  i+=Step; //    

 } while (i<=180);

//   
settextjustify(RIGHT_TEXT,BOTTOM_TEXT);

 //      - 
 j=-90+Step;
 do {
  if (j!=0)  //   
  {
   b=rad(j);
   Aitoff(0,b,x,y);
   Screen(x,y,X0,Y0,Scale,u,v);
   itoa(j,s,10);
   outtextxy(u-5,v-5,s);
   }
   j+=Step;
 } while (j<=90-Step);

}

//     
void Galaxy(
 double a, double d, //  
 double &l, double &b) // 
{
 double sa,ca,sd,cd;
 double const Leo = 4.936829261;   // 282.85948083
 double const L0  = 0.57477039907; // 32.931918056
 double const si  = 0.88998807641; // sin 62.871748611
 double const ci  = 0.45598379779; // cos 62.871748611

 a=a-Leo;
 sa=sin(a); ca=cos(a);
 sd=sin(d); cd=cos(d);
 b=asin(sd*ci-cd*si*sa);
 l=atan2(sd*si+cd*ci*sa,cd*ca)+L0;
}

void main()
{
   TTycho2 s;
   int driver,mode; //   . 
   int color;       //  
   double l, b;     //  
   double x, y;     //  
   int u, v;        //  
   int CX, CY;      //    
   int SC; //    .  
   int rgb;
   char t[4];

 //   
 driver=DETECT; mode=0; initgraph(&driver,&mode,"D:/BC/BGI");

 //    X    -2  2,  
 SC=getmaxx()/4-10;
 CX=getmaxx()/2; CY=getmaxy()/2;
 setcolor(15);
 AitoffGrid(30,CX,CY,SC,1); //   

 OpenTycho2();
 while (ReadTycho2(&s))  //   
 { if (s.magn.NoVT) continue;
   if ((s.VT>=Vmin) && (s.VT<=Vmax))
  {
   //     ,  
   //    
   Galaxy(rad(s.RAdeg),rad(s.DEdeg),l,b);
  //     
   Aitoff(l,b,x,y);
   Screen(x,y,CX,CY,SC,u,v); //    
   color=getpixel(u,v);
   switch (color)
   {
    case BLACK:     color=DARKGRAY;  break;
    case DARKGRAY:  color=LIGHTGRAY; break;
    case LIGHTGRAY: color=WHITE; break;
    default: color=WHITE;
   }
   putpixel(u,v,color); //   
 }
 }; // if  while
 CloseTycho2();
 getch();
}

