#include "photodis.h"
#include <math.h>
 float const Mv_V[13] =
 { -5.7,-4.0,-1.2,0.6,1.9,2.7,3.5,4.4,5.1,5.9,7.4,8.8,12.3};
 //  O5   B0   B5  A0  A5  F0  F5  G0  G5  K0  K5  M0   M5
 //   0    1    2   3   4   5   6   7   8   9  10  11   12
 float const BV_V [13] =
 { -0.33,-0.30,-0.17,-0.02,0.15,0.30,0.44,0.58,0.68,0.81,1.15,1.40,1.64};
 //   O5    B0    B5    A0   A5   F0   F5   G0   G5   K0   K5   M0   M5
 float const Mv_III[5] = { 0.9, 0.7, -0.2, -0.4, -0.3 };
			//  G5   K0    K5    M0    M5
 float const BV_III[5] = { 0.86, 1.00, 1.50, 1.56, 1.63 };
			 // G0   G5   K0   K5   M0   M5
 float const Mv_Ia[12] =
 { -6.8,-6.9,-7.0,-7.1,-7.4,-8.0,-8.0,-8.0,-7.9,-7.7,-7.5,-7.0};
 // O5   B0    B5   A0   A5   F0   F5   G0   G5   K0   K5   M0
 float const BV_Ia[12] =
 { -0.31,-0.23,-0.08,0.02,0.09,0.17,0.31,0.75,1.03,1.25,1.60,1.67};

// ᫥ ⬥᪮ ﭨ

 bool PhotoDistance(  // true -  砥 ᯥ譮 ।
    char TClass,  //  
    char SClass,  //  
    char LClass,  //  ᢥ⨬
    float MagVis, // 㠫쭠  稭
    float B_V,
    float &r  //  - ﭨ  
    )
{
 int SubCl, SpCl, Sp;
 float x;
 double y;
 int   k;
 float Mtab,BVtab;

  // PhotoDistance=False;
  if (LClass!='1' && LClass!='3' && LClass!='5') return false;
  switch(TClass)
  {
   case 'W': case 'O': SpCl=0; break;
   case 'B' : SpCl=10; break;
   case 'A' : SpCl=20; break;
   case 'F' : SpCl=30; break;
   case 'G' : SpCl=40; break;
   case 'K': case 'R': SpCl=50; break;
   case 'M': case 'N': case 'S': case 'C': case 'P': SpCl=60; break;
   default: return false;
  }
  if (SClass==' ') SClass='5';
  SubCl=SClass-'0';
  Sp=SpCl+SubCl;
  switch(LClass)
  {
   case '5': if (Sp<5) Sp=5; else if (Sp>65) Sp=65;
	     Sp=Sp-5;
	     break;
   case '3': if (Sp<45) Sp=45; else if (Sp>65) Sp=65;
	     Sp=Sp-45;
	     break;
   case '1': if (Sp<5) Sp=5; else if (Sp>60) Sp=60;
	     Sp=Sp-5;
	     break;
   default: return false;
  }
  x=Sp/5.0;
  x=modf(x,&y); k=int(y);
  switch (LClass)
  {
   case '5': if (k==12) { Mtab =Mv_V[k]; BVtab=BV_V[k]; }
	     else {
	     Mtab =Mv_V[k]+x*(Mv_V[k+1]-Mv_V[k]);
	     BVtab=BV_V[k]+x*(BV_V[k+1]-BV_V[k]);
	     }
	     break;
   case '3': if (k==4) { Mtab =Mv_III[k]; BVtab=BV_III[k]; }
	     else {
	     Mtab =Mv_III[k]+x*(Mv_III[k+1]-Mv_III[k]);
	     BVtab=BV_III[k]+x*(BV_III[k+1]-BV_III[k]);
	     }
	     break;
   case '1': if (k==11) { Mtab =Mv_Ia[k]; BVtab=BV_Ia[k]; }
	     else {
	     Mtab =Mv_Ia[k]+x*(Mv_Ia[k+1]-Mv_Ia[k]);
	     BVtab=BV_Ia[k]+x*(BV_Ia[k+1]-BV_Ia[k]);
	     }
	     break;
   default: return false;
  }
  r=0.2*(MagVis-Mtab)+1.0-0.2*3.0*(B_V-BVtab);
  r=pow(10.0,r);
  return true;
 }

