
//    tycho2

//      Tycho2
#define Tycho2Name "D:/CATALOGS/TYCHO-2/Data/catalog.dat"
#define Tycho2NumOfStars  2539913

 typedef struct
  {
      // 
      unsigned TYC1; // [1..9537] 
      unsigned TYC2; // [1..12121] 
      unsigned TYC3; // [1..3] 
      //       J2000.0
      char pflag; /* [ PX]
                     ' ' -     ..
                     'P' -    .. ,
                     'X' -     .. */
       double mRAdeg, mDEdeg;  //  RA  Dec  J2000.0
       double pmRA,   pmDE;  //  ..  J2000.0
       float e_mRA,  e_mDE;  //  RA  DE   
       float e_pmRA, e_pmDE; //   
       float mepRA,  mepDE;  //   RA  DE
       unsigned Num;  //   
       float g_mRA,  g_mDE;  //    RA  DE   Num>2
       float g_pmRA, g_pmDE; //   .   Num>2
       float BT,     e_BT;   //   BT  . (. Info)
       float VT,     e_VT;   //   VT  . (. Info)
       unsigned prox;        //   
       char TYC;             //    Tycho-1 'T'  ' '
       long HIP; //     Hipparcos  0
       char CCDM[4]; //  CCDM   Hipparcos
       double RAdeg,  DEdeg; // RA  DE   Tycho-2, ICRS
       float epRA,   epDE;   // -1990.0  RAdeg, DEdeg
       float e_RA,   e_DE;    //  RAdeg, DEdeg,   
       char postflg;  /*    Tycho2: ' ' - ,
                                 'D' -  , 'P' -  */
       float corr; //   RAdeg  DEdeg
       struct
        {
         unsigned NoBT:1; //    BT
         unsigned NoVT:1; //    VT
        } magn;     //    BT  VT
   } TTycho2;

  //  
  void OpenTycho2();  //   
  void CloseTycho2(); //    

  /*    :
       s,
     false     */
  int ReadTycho2(TTycho2 *star);

