PROGRAM MagnDistribution
USE Tycho2

IMPLICIT NONE

TYPE(TTycho2) :: s

REAL(4), PARAMETER :: Delta =   0.5  !     
REAL(4), PARAMETER :: MinV  =  -1.0 !     
REAL(4), PARAMETER :: MaxV  = +16.0 !    
CHARACTER(*), PARAMETER :: Res  = 'statist.txt' !   
INTEGER(4), PARAMETER ::   N    = FLOOR((MaxV-MinV)/0.5+0.5);
INTEGER(4) ::  k = 0
INTEGER(4) ::  step = Tycho2NumOfStars/80

REAL(4) ::  V !   
INTEGER(4) ::  A(0:N) ! 
INTEGER(4) ::  i
INTEGER(4), PARAMETER :: f = 20


FORALL (i=0:N) A(i)=0

CALL OpenTycho2
 DO WHILE (ReadTycho2(s))
  k=k+1
  IF (mod(k,step)==0) print *, '*'
  IF (s.NoVT .or. s.NoBT)  CYCLE !  
  V=(s.VT-0.090*(s.BT-s.VT));
  i=FLOOR((V-MinV)/Delta+0.5) !    
  IF ((i>=0) .and. (i<=N)) a(i)=a(i)+1 ! . 1 
 END DO
 CALL CloseTycho2
 OPEN(f, file = Res)
 WRITE (f,'(F6.2,1X,I7)'),(i*Delta+MinV,a(i),i=0,N)
 CLOSE(f)
END PROGRAM


