
MODULE Projection
USE DFLIB

IMPLICIT NONE


REAL(8), PARAMETER :: PI = 3.1415926535897932384626433832795


CONTAINS
  

SUBROUTINE Aitoff(l,b,x,y)
 REAL(8), INTENT(IN) :: l,b  !     
 REAL(8), INTENT(OUT) :: x,y !   
 REAL(8) :: s, l1  !  
 IF (l>PI) THEN !  l   -Pi  +Pi 
   l1=l-2*Pi 
  ELSE 
   l1=l
 END IF
 S=sqrt(1.0+cos(b)*cos(l1/2)) !   (4.1)
 x=-2*cos(b)*sin(l1/2)/s
 y=sin(b)/s
 END SUBROUTINE Aitoff


REAL(8) FUNCTION radi(x) !     
INTEGER, INTENT(IN) :: x
 radi=x/180.0*PI
END FUNCTION radi

REAL(8) FUNCTION rad(x) !     
REAL(8), INTENT(IN) :: x
 rad=x/180.0*PI
END FUNCTION rad



SUBROUTINE AitoffGrid (Step,Gr)

 INTEGER, INTENT(IN) :: Step  !     
 LOGICAL, INTENT(IN) :: Gr !  -       

 INTEGER :: i,j !   for 
 REAL(8) :: l,b !   
 REAL(8) :: x,y !   
 CHARACTER(8)  s !    
 INTEGER ::  h  !    
 
 TYPE (wxycoord) wxy
 INTEGER(2) :: status2
 INTEGER(4) :: status4
 
 !    
 
 status4 = SetColorRGB(#00FF00)

 DO i=-180,+180,Step
  l=radi(i) !     }
  DO j=-90,+90,5 !     
   !    
   b=radi(j) !     
   CALL Aitoff(l,b,x,y) !     
   !    (j=-90),    
   !    (x,y)  MoveTo_W,    , 
   ! ""      
   !    (u,v)  LineTo_W.
   IF (j==-90) THEN
     CALL MoveTo_W(x,y,wxy) 
	ELSE 
	 status2=LineTo_W(x,y);
   END IF
  END DO ! j
 END DO ! i

 !    -   
 DO j=-90,+90,Step
  b=radi(j)
  DO i=-180,+180,5  !     
   l=radi(i)
   CALL Aitoff(l,b,x,y);
   if (i==-180) then 
     CALL MoveTo_W(x,y,wxy)
    else 
	 status2=LineTo_W(x,y)
   end if
  END DO ! i
 END DO ! j

 status2=SetFont('t''Arial''h10')
 status4 = SetColorRGB(#FFFFFF)

 !     
 DO i=-180,+180,Step
  !      
  l=Radi(i);
  CALL Aitoff(l,0.0_8,x,y)
  !  Gr ,    ,   -  
  if (Gr) then  
    h=i
  else 
    h=i/15 
	if (h<0) h=h+24;
  end if
  write(s,'(I4)') h !   h     
  Call MoveTo_W(x, y, wxy)
  Call OUTGTEXT(s)
 END DO


 !      -  
 DO j=-90,+90,Step
  if (j /= 0) then !    
   b=Radi(j);
   CALL Aitoff(0.0_8,b,x,y)
   write(s,'(I4)') j 
   Call MoveTo_W(x, y, wxy)
   Call OUTGTEXT(s)
  end if
 END DO

END SUBROUTINE AitoffGrid


SUBROUTINE Galaxy(a,d,l,b)
REAL(8), INTENT(in) :: a,d
REAL(8), INTENT(out) :: l,b
REAL(8) :: a1,sa,ca,sd,cd

REAL(8), PARAMETER :: Leo = 4.936829261   ! 282.85948083 
REAL(8), PARAMETER :: L0  = 0.57477039907 ! 32.931918056  
REAL(8), PARAMETER :: si  = 0.88998807641 ! sin 62.871748611 
REAL(8), PARAMETER :: ci  = 0.45598379779 ! cos 62.871748611 
 
  a1=a-Leo
  sa=sin(a1); ca=cos(a1)
  sd=sin(d);  cd=cos(d)
  b=asin(sd*ci-cd*si*sa)
  l=atan2(sd*si+cd*ci*sa,cd*ca)+L0

end subroutine Galaxy



END MODULE