Program Main

USE DFLIB
USE Tycho2
USE Plane
USE LoadSp

IMPLICIT NONE

REAL(8), PARAMETER :: A0 = 56.5, D0 = 23.97 !     
REAL(8), PARAMETER :: R0 = 4.0 !   
REAL(4), PARAMETER :: Mmin=2   !    
REAL(4), PARAMETER :: Mmax=10  !     
REAL(4), PARAMETER :: Time = 10000.0 !  

INTEGER, PARAMETER :: MaxXY = 700 !   
REAL(8) :: XYMax !   
REAL(8)  :: scale  !  
REAL(8), PARAMETER :: Vmin = 1.0 , Vmax = 15.0 !    . .


REAL(8) :: l, b !   
REAL(8) :: x, y !   

CHARACTER(2) :: t !   

INTEGER(1) :: status1
INTEGER(2) :: status2
INTEGER(4) :: status4

INTEGER(4) :: color

INTEGER(4) :: r !   
REAL(8) a1,d1   !     

INTEGER(2) :: ix,iy, delta

REAL(4) ::  B_V

TYPE(TTycho2) s

CHARACTER(1) :: Sp(2), Lum
 
TYPE (windowconfig) wc
TYPE (wxycoord) wxy
TYPE (xycoord) xy

 wc.numxpixels  = MaxXY
 wc.numypixels  = MaxXY
 wc.numtextcols = -1
 wc.numtextrows = -1
 wc.numcolors   = -1
 wc.title = "Aitoff"C
 wc.fontsize = #0008000C ! 10 X 12

 status1 = SETWINDOWCONFIG(wc)
 IF (.NOT. status1) status1 = SETWINDOWCONFIG(wc)

 XYmax = DTAND(R0)
 scale  = (MaxXY/2)/XYmax

 status2=SetWindow(.TRUE.,-XYmax, -XYmax, +XYmax, +XYmax)

 status2=INITIALIZEFONTS( )
 status2=SetFont('t''Arial''h10')


 DO r=2,13 ! 
  ix=R*20; iy=MAXXY-20; delta=7-r/2;
  status4=ELLIPSE($GBORDER,ix-delta,iy-delta,ix+delta,iy+delta)
  write(t,'(I2)') r 
  CALL MoveTo(ix-r/2,iy-20,xy)
  CALL OutGText(t)
 END DO

 CALL OpenTycho2
 CALL LoadSpData

 DO WHILE (ReadTycho2(s))
  !      }
  IF (s.NoVT .or. s.NoBT) CYCLE
  IF (s.VT<Mmin  .or. s.VT>Mmax) CYCLE
  IF (ToPlane(A0,D0,s.RAdeg,s.DEdeg,R0,x,y)) THEN
   r=7-FLOOR(s.VT/2+0.5); IF (r<1) r=1
   !   ,     
  IF (FindSpData(s.TYC1,s.TYC2,s.TYC3,Sp(1),Sp(2),Lum)) THEN
   SELECT CASE (Sp(1) )
      CASE('W','O','B')
 	    color=RGBTOINTEGER(0,127,255)
      CASE ('A')
 	    color=RGBTOINTEGER(255,255,255)
      CASE ('F')
	    color=RGBTOINTEGER(255,255,127)
      CASE ('G')
	    color=RGBTOINTEGER(255,255,0)
      CASE ('K','R')
	    color=RGBTOINTEGER(255,127,0)
      CASE ('M','N','S','C','P')
	    color=RGBTOINTEGER(255,0,0)
   END SELECT 
  ELSE
   color=RGBTOINTEGER(0,255,0)
  END IF


   status4=SETCOLORRGB(color)
   status4=ELLIPSE_W($GFILLINTERIOR,x-r/scale,y-r/scale,x+r/scale,y+r/scale)

   IF (s.pflag/='X') THEN
     a1=s.RAdeg+(s.pmRA*0.001/3600.0)/dcosd(s.DEdeg)*Time;
     d1=s.DEdeg+(s.pmDE*0.001/3600.0)*Time;
	 CALL MoveTo_W(x,y,wxy)
     status4=ToPlane(A0,D0,a1,d1,R0,x,y)
     status4=LineTo_W(x,y)
   ENDIF
  END IF
 END DO 
 CALL CloseTycho2
 !    
  status4=SaveImage("LOCALPICTURE.bmp"C,0,0,MaxXY-1,MaxXY-1)
END PROGRAM
