MODULE PLANE
USE DFLIB

IMPLICIT NONE

CONTAINS


Logical Function ToPlane(A0,D0,a,d,maxr,x,y)
!  true     
REAL(8), INTENT(IN) :: A0,D0 !     
REAL(8), INTENT(IN) :: a, d  !    
REAL(8), INTENT(IN) :: maxr  ! r      
REAL(8), INTENT(OUT):: x,y   !   

REAL(8) :: SinD0, CosD0, sd,cd,cr,sr,tr,sf,cf,r

sd=dsind(d); cd=dcosd(d);
SinD0=dsind(D0); CosD0=dcosd(D0);
cr=SinD0*sd+CosD0*cd*dcosd(A0-A);
IF (cr>dcosd(maxr)) THEN
  sr=DSQRT(1.0-cr**2);
  tr=sr/cr
  IF (sr<0.0000001) THEN
     sf=0.0; cf=0.0
  ELSE
     sf=(cd*dsind(A0-A))/sr;
     cf=(sd-cr*SinD0)/(sr*CosD0)
  END IF
  r=tr
  X=r*sf; Y=r*cf
  ToPlane=.TRUE.
 ELSE 
   ToPlane=.FALSE.
 END IF
END FUNCTION ToPlane

END MODULE
