MODULE Tycho2

IMPLICIT NONE

!   Tycho2
CHARACTER(*), PARAMETER :: Tycho2Name = 'D:\CATALOGS\TYCHO-2\DATA\catalog.dat'
!    Tycho2
INTEGER, PARAMETER ::  Tycho2NumOfStars = 2539913



INTEGER, PARAMETER :: u = 11 !  



TYPE  TTycho2
 INTEGER(2) ::   TYC1  ! [1,9537]+=  TYC1  TYC  GSC 
 INTEGER(2) ::   TYC2  ! [1,12121]   TYC2  TYC  GSC
 INTEGER(2) ::   TYC3  ! [1,3]  TYC3  TYC
 
 !   ,  pflag .NEQ. 'X'
 CHARACTER(1) :: pflag ! ' ' -     ..
                       ! 'P' -    .. ,
                       ! 'X' -    ,  ..,   
 REAL(8) :: mRAdeg, mDEdeg ! (deg)  RA  Dec  J2000.0
 REAL(8) :: pmRA, pmDE     ! (mas/yr)  ..  J2000.0
 REAL(4) :: e_mRA, e_mDE     ! (mas)  RA  DE   
 REAL(4) :: e_pmRA, e_pmDE !   
 REAL(4) :: mepRA, mepDE   !   RA  DE
 INTEGER(4) ::   Num       !   
 REAL(4) :: g_mRA,  g_mDE  !    RA  DE   Num>2
 REAL(4) :: g_pmRA, g_pmDE !   .   Num>2
 
 
 REAL(4) :: BT, e_BT ! (mag)   BT  . (. NoBT) 
 REAL(4) :: VT, e_VT ! (mag)   BT  . (. NoVT) 
 
 INTEGER(4) ::   prox   ! (0.1arcsec)   
 
 CHARACTER(1)    TYC    !    Tycho-1 'T'  ' ' 
 INTEGER(4) ::   HIP    !    Hipparcos  0
 CHARACTER(3)    CCDM   !  CCDM   Hipparcos 
 
 REAL(8) :: RAdeg, DEdeg ! (deg) RA  DE   Tycho-2, ICRS 
 REAL(4) :: epRA, epDE   ! (yr) -1990.0  RAdeg, DEdeg 
 REAL(4) :: e_RA, e_DE  !  RAdeg, DEdeg,    
 
 CHARACTER(1) ::  posflg !    Tycho2: ' ' - ,
                         ! 'D' -  , 'P' -  
 REAL(4) :: corr   !   RAdeg  DEdeg 
 
 LOGICAL(1)::    NoBT   !      BT
 LOGICAL(1)::    NoVT   !      VT

END TYPE TTYCHO2

CONTAINS
  
 !      " " 
 SUBROUTINE OpenTycho2
  OPEN(u, file = Tycho2Name)
 END SUBROUTINE OpenTycho2

 !    
 SUBROUTINE  CloseTycho2
   CLOSE(u)
 END SUBROUTINE  CloseTycho2


 LOGICAL FUNCTION ReadTycho2(s)
 TYPE(TTycho2), INTENT(out) :: s
 CHARACTER(206) :: buf !   

100 FORMAT(I4,1X,I5,1X,I1,1X,A1,1X,F12.8,1X,F12.8,1X,F7.1,1X,F7.1,1X,    &
           I3,1X,I3,1X,F4.1,1X,F4.1,1X,F7.2,1X,F7.2,1X,I2,1X,F3.1,1X,    &
		   F3.1,1X,F3.1,1X,F3.1,1X,F6.3,1X,F5.3,1X,F6.3,1X,F5.3,1X,I3,   &
		   1X,A1,1X,I6,A3,1X,F12.8,1X,F12.8,1X,F4.2,1X,F4.2,1X,F5.1,1X,  &
		   F5.1,1X,A1,1X,F4.1)

!  Effective file loading

 IF (EOF(u)) THEN 
   ReadTycho2=.false.
   RETURN
  ELSE
   ReadTycho2=.true.
 END IF

   read(u,'(A206)') buf
   read(buf,100)  s.TYC1,s.TYC2,s.TYC3,s.pflag,s.mRAdeg,s.mDEdeg, &
       s.pmRA,s.pmDE,s.e_mRA,s.e_mDE,s.e_pmRA,s.e_pmDE,s.mepRA,s.mepDE,  &
	   s.Num,s.g_mRA,s.g_mDE,s.g_pmRA,s.g_pmDE,s.BT,s.e_BT,s.VT,s.e_VT,s.prox,   &       
	   s.TYC,s.HIP,s.CCDM,s.RAdeg,s.DEdeg,s.epRA,s.epDE,s.e_RA,s.e_DE,s.posflg,s.corr

   IF(buf(111:116) .EQ. '') THEN
    s.NoBT=.true.
   ELSE
    s.NoBT=.false.
   END IF 
    
   IF(buf(124:129) .EQ. '') THEN
    s.NoVT=.true.
   ELSE
    s.NoVT=.false.
   END IF 

   IF(buf(143:148) .EQ. '') THEN
    s.HIP = 0
    s.CCDM=''
   END IF 
 END FUNCTION ReadTycho2


END MODULE Tycho2