PROGRAM PhotoDistDistrib
!   Tycho-2 Spectral Type    
USE Tycho2Sp
USE PhotoDist
USE DFPort

IMPLICIT NONE

TYPE(TTycho2Sp)   star

CHARACTER(*), PARAMETER :: Res = 'photodist2.txt' !   
INTEGER(4) :: k = 0 
INTEGER(4),PARAMETER :: step = Tycho2SpNumOfStars / 80
INTEGER(2),PARAMETER :: N = 15      !    
REAL(4),PARAMETER :: delta = 100.0  !    
!      
INTEGER(4) :: Dist_V   (0:N) = (/(0,i=0,N)/) !   
INTEGER(4) :: Dist_III (0:N) = (/(0,i=0,N)/) !  
REAL(4) :: Mj,BVj !    B-V    
REAL(4) r  !    
INTEGER(4) i
INTEGER(4),PARAMETER :: f = 15
INTEGER(4) :: code

CALL OpenTycho2Sp
DO WHILE (ReadTycho2Sp(star))
  k=k+1; IF (MOD(k,step)==0) code=PUTC('*')
  IF (star.NoVT .OR. star.NoBT) CYCLE
  Mj =star.VT-0.090*(star.BT-star.VT)
  BVj=0.850*(star.BT-star.VT)
  IF (PhotoDistance(star.TClass,star.SClass,star.LClass,Mj,BVj,r)) THEN
   i=floor(r/Delta)
   IF (i>N) i=N
   SELECT CASE (star.LClass)
   CASE('3')
     Dist_III(i)=Dist_III(i)+1
   CASE('5')
     Dist_V(i)=Dist_V(i)+1
   END SELECT
  END IF
 END DO

 CALL CloseTycho2Sp
 !   
 OPEN(UNIT=f,FILE=Res) 
 DO i=0,N 
  WRITE(f,"(I4,'-',I4,I7,I7)") FLOOR(i*Delta),FLOOR((i+1)*Delta),Dist_V(i),Dist_III(i)
 END DO
 CLOSE(UNIT=f)
END PROGRAM
