MODULE PhotoDist
!    

IMPLICIT NONE

 REAL(4), PARAMETER :: Mv_V (0:12) = & 
 (/ -5.7,-4.0,-1.2,0.6,1.9,2.7,3.5,4.4,5.1,5.9,7.4,8.8,12.3/)
 !  O5   B0   B5  A0  A5  F0  F5  G0  G5  K0  K5  M0   M5 
 !   0    1    2   3   4   5   6   7   8   9  10  11   12 
 REAL(4), PARAMETER :: BV_V(0:12) = &
 (/ -0.33,-0.30,-0.17,-0.02,0.15,0.30,0.44,0.58,0.68,0.81,1.15,1.40,1.64 /)
 !   O5    B0    B5    A0   A5   F0   F5   G0   G5   K0   K5   M0   M5 
 REAL(4), PARAMETER :: Mv_III(0:4) = (/0.9, 0.7,-0.2,-0.4,-0.3/)
                                     !  G5   K0   K5   M0   M5 
 REAL(4), PARAMETER :: BV_III(0:4) = (/ 0.86,1.00,1.50,1.56,1.63/)
                                       ! G5   K0   K5   M0   M5 
 REAL(4), PARAMETER :: Mv_Ia(0:11) = &
 (/-6.8,-6.9,-7.0,-7.1,-7.4,-8.0,-8.0,-8.0,-7.9,-7.7,-7.5,-7.0/)
 !  O5   B0    B5   A0   A5   F0   F5   G0   G5   K0   K5   M0 
 REAL(4), PARAMETER :: BV_Ia(0:11) = &
 (/ -0.31,-0.23,-0.08,0.02,0.09,0.17,0.31,0.75,1.03,1.25,1.60,1.67/)

CONTAINS


 LOGICAL FUNCTION PhotoDistance(TClass,SClass,LClass,MAgVis,B_V,r)
 !  .true.      

 CHARACTER, INTENT(IN) :: TClass !   
 CHARACTER, INTENT(IN) :: SClass !   
 CHARACTER, INTENT(IN) :: LClass !   
 REAL(4), INTENT(IN)   :: MagVis !    
 REAL(4), INTENT(IN)   :: B_V    !   
 REAL(4), INTENT(OUT)  ::  r     !  -    
 
 INTEGER(2) :: SubCl, SpCl, Sp 
 REAL(4) ::    x
 INTEGER(2) :: k
 REAL(4) :: Mtab,BVtab

 
  PhotoDistance=.false.

  IF (LClass/='1' .and. LClass/='3' .and. LClass/='5') RETURN

  SELECT CASE(TClass)
   CASE ('W','O')
     SpCl=0
   CASE ('B')        
     SpCl=10
   CASE ('A')        
     SpCl=20
   CASE ('F')
     SpCl=30
   CASE ('G')
     SpCl=40
   CASE ('K','R')
     SpCl=50
   CASE ('M','N','S','C','P')
     SpCl=60
   CASE DEFAULT
     RETURN
  END SELECT

  IF (SClass==' ') THEN
    SubCl=5
  ELSE
    SubCl=ICHAR(SClass)-ICHAR('0')
  END IF

  Sp=SpCl+SubCl
  
  SELECT CASE (LClass)
   CASE ('5') 
      IF (Sp<5)  Sp=5 
	  IF (Sp>65) Sp=60
      Sp=Sp-5
       
   CASE ('3')
      IF (Sp<45) Sp=45 
	  IF (Sp>65) Sp=60
      Sp=Sp-45

   CASE ('1')
      IF (Sp<5) Sp=5 
	  IF (Sp>60) Sp=55
      Sp=Sp-5

   CASE DEFAULT
     RETURN
  END SELECT
  
  x=Sp/5.0
  k=FLOOR(x);  x=x-k
  
  SELECT CASE (LClass)
   CASE('5')
          IF (k==12) THEN
            Mtab=Mv_V(k); BVtab=BV_V(k)
          ELSE
           Mtab =Mv_V(k)+x*(Mv_V(k+1)-Mv_V(k))
           BVtab=BV_V(k)+x*(BV_V(k+1)-BV_V(k))
          END IF
   CASE('3')
           IF (k==4) THEN
             Mtab=Mv_III(k); BVtab=BV_III(k)
           ELSE
             Mtab =Mv_III(k)+x*(Mv_III(k+1)-Mv_III(k))
             BVtab=BV_III(k)+x*(BV_III(k+1)-BV_III(k))
           END IF
   CASE('1')
           IF (k==11) THEN
             Mtab=Mv_Ia(k); BVtab=BV_Ia(k)
           ELSE
             Mtab =Mv_Ia(k)+x*(Mv_Ia(k+1)-Mv_Ia(k))
             BVtab=BV_Ia(k)+x*(BV_Ia(k+1)-BV_Ia(k))
           END IF  
   CASE DEFAULT
    RETURN
  END SELECT

  r=0.2*(MagVis-Mtab)+1-0.2*3.0*(B_V-BVtab)
  r=10.0**r
  PhotoDistance=.True.
  RETURN
 END FUNCTION

END MODULE
