PROGRAM HRDiagramm !  HR- 
USE Tycho2Sp
USE PhotoDist
USE DFLIB

IMPLICIT NONE

REAL(4), PARAMETER ::  MagLow =15.0, MagHi =-10.0  !   AbsMag 
INTEGER, PARAMETER ::  Border = 50 !      
INTEGER, PARAMETER ::  MaxXY = 599

CHARACTER(7), PARAMETER ::  sps = 'OBAFGKM';

REAL(8) :: ScaleMg !    . .  }
REAL(8) :: ScaleSP !     


!    
TYPE (windowconfig) wc 
TYPE (xycoord) t
INTEGER(1) :: status1
INTEGER(2) :: status2
INTEGER(4) :: status4

CHARACTER(3) buf !      
TYPE(TTYcho2Sp) star 
REAL(4) ::  Mj,BVj !    B-V    
REAL(4) ::  r      !    
REAL(4) Mag  !    
INTEGER(4) ::  x,y,x1,y1  !   
INTEGER(4) ::  color !   
INTEGER(2) ::  i 

 !    }
 wc.numxpixels  = MaxXY
 wc.numypixels  = MaxXY
 wc.numtextcols = -1
 wc.numtextrows = -1
 wc.numcolors   = -1
 wc.title = "HR-diagram"C
 wc.fontsize = #0008000C ! 10 X 12

 status1 = SETWINDOWCONFIG(wc)
 IF (.NOT. status1) status1 = SETWINDOWCONFIG(wc)

 status2=INITIALIZEFONTS()
 status2=SetFont('t''Arial''h10')


 !     
 ScaleMg=(MaxXY-2*Border)/(MagLow-MagHi)
 ScaleSP=(MaxXY-2*Border)/(LineSp('M','9')-LineSp('O','1'))

 !    
 CALL XY('O','1',MagHi,x,y) 
 CALL XY('M','9',MagLow,x1,y1) 
 status2=Rectangle($GBORDER,x,y,x1,y1);

 !    
 DO i=1,7
  IF (i/=1) THEN
    CALL XY(Sps(i:i),'0',15.0,x,y)
	CALL MoveTo(x,y,t); status2=LineTo(x,y+3)
	CALL MoveTo(x,y+5,t); CALL OutGText(Sps(i:i) // '0')
  END IF
  CALL XY(Sps(i:i),'5',15.0,x,y)
  CALL MoveTo(x,y,t); status2=LineTo(x,y+3)
  CALL MoveTo(x,y+5,t); CALL OutGText(Sps(i:i) // '5')
 END DO


 !   . .  
 DO Mag=MagHi,MagLow,5.0
  CALL XY('O','1',Mag,x,y)
  CALL MoveTo(x,y,t); status2=LineTo(x-3,y)
  WRITE(buf,'(I3)') FLOOR(Mag)
  CALL MoveTo(x-15,y,t); CALL OutGText(buf)
 END DO

 CALL OpenTycho2SP
 DO WHILE (ReadTycho2Sp(star)) 
  IF (star.NoVT .or. star.NoBT) CYCLE
  Mj  =star.VT-0.090*(star.BT-star.VT);
  BVj =0.850*(star.BT-star.VT);
  IF (.not. PhotoDistance(star.TClass,star.SClass,star.LClass,Mj,BVj,r)) CYCLE
  Mag=Mj-5.0*log10(r)+5.0 ! . . . 
  CALL XY(star.TClass,star.SClass,Mag,x,y);
  SELECT CASE (star.LClass) 
  CASE ('1')
    color=RGBTOINTEGER(0,0,255)
  CASE ('2')
    color=RGBTOINTEGER(0,255,255)
  CASE ('3')
    color=RGBTOINTEGER(255,0,0)
  CASE ('4')
    color=RGBTOINTEGER(255,255,0)
  CASE ('5') 
    color=RGBTOINTEGER(0,255,0)
  END SELECT
  status4=SetColorRGB(color)
  status2=SetPixel(x,y)
 END DO
 CALL CloseTycho2Sp
 status4=SaveImage("HR.bmp"C,0,0,MaxXY,MaxXY)
 
CONTAINS

 INTEGER FUNCTION LineSp(Sp,SubSp)
 CHARACTER :: Sp,SubSp
 INTEGER(2) ::   SpCl
 
  SELECT  CASE(Sp)
   CASE('W','O')
         SpCl=0
   CASE('B')
         SpCl=10
   CASE('A')
         SpCl=20
   CASE('F')
         SpCl=30
   CASE('G')
         SpCl=40
   CASE('K','R')
         SpCl=50
   CASE('M','N','S','C','P')
         SpCl=60
   CASE DEFAULT 
         SpCl=-9999
  END SELECT
  IF (SubSp==' ') SubSp='5'
  LineSp=SpCl+ICHAR(SubSp)-ICHAR('0')
 END FUNCTION


 !      . .     
 SUBROUTINE XY(Sp,SubSp,Mag,x,y)
 CHARACTER, INTENT(IN) :: Sp,SubSp
 REAL(4), INTENT(IN) :: Mag
 INTEGER(4),INTENT(OUT) :: x,y 
  x=Border+FLOOR(LineSp(Sp,SubSp)*ScaleSP+0.5)
  y=Border+FLOOR((Mag-MagHi)*ScaleMg+0.5)
 END SUBROUTINE


END PROGRAM
