MODULE Tycho2Sp

IMPLICIT NONE

!   Tycho2Sp
CHARACTER(*), PARAMETER :: Tycho2SpName = 'D:\CATALOGS\TYCHO-2 Spectral Types\catalog.dat'
!    Tycho2 Spectral Types
INTEGER, PARAMETER ::  Tycho2SpNumOfStars = 351863

INTEGER, PARAMETER :: usp = 12 !  

TYPE  TTycho2SP
 !  }
 INTEGER(2) :: TYC1 !  TYC1 
 INTEGER(2) :: TYC2 !  TYC2 
 INTEGER(2) :: TYC3 !  TYC3 
 !    J2000.0 
 REAL(8) :: mRAdeg, mDEdeg !  RA  Dec  J2000.0 
 REAL(4) :: BT !   BT 
 REAL(4) :: VT !   VT 
 CHARACTER(3) :: r_SpType !    
 CHARACTER(15) :: Name !    
 REAL(4) :: Dist !    Tycho-2  
                 !     
 REAL(4) :: Mag !       
 CHARACTER(1) :: f_Mag  !    [VPBX*] 
 CHARACTER(1) :: TClass !   
 CHARACTER(1) :: SClass !   
 CHARACTER(1) :: LClass !   
 INTEGER(4) ::Teff  !   
 CHARACTER(20) :: SpType !     

 LOGICAL(1) ::  NoBT  !      BT 
 LOGICAL(1) ::  NoVT  !      VT 
 LOGICAL(1) ::  NoMag !      Mag 
 LOGICAL(1) ::  NoS   !      
 LOGICAL(1) ::  NoL   !      

END TYPE TTycho2SP

CONTAINS


!      " " 
SUBROUTINE OpenTycho2Sp
  OPEN(usp, file = Tycho2SpName)
END SUBROUTINE OpenTycho2Sp

!    
SUBROUTINE  CloseTycho2Sp
   CLOSE(usp)
END SUBROUTINE  CloseTycho2Sp


LOGICAL FUNCTION ReadTycho2Sp(s)
  TYPE(TTycho2Sp), INTENT(out) :: s
 
  200 FORMAT(4X,I4,1X,I5,1X,I1,1X,F12.8,1X,F12.8,1X,F6.3,1X,F6.3,1X,A3,1X, &
          A15,1X,F6.3,1X,F6.2,1X,A1,1X,A1,A1,1X,A1,1X,I5,1X,A20)

  IF (EOF(usp)) THEN 
    ReadTycho2Sp=.false.
    RETURN
  ELSE
   ReadTycho2Sp=.true.
  END IF


  READ(usp,200)  s.TYC1,s.TYC2,s.TYC3,s.mRAdeg,s.mDEdeg,s.VT,s.BT,s.r_SpType,s.Name, &
                 s.Dist,s.Mag,s.f_Mag,s.TClass,s.SClass,s.LClass,s.Teff,s.SpType

  s.NoVT=s.VT>99.9;  s.NoBT=s.BT>99.9;  s.NoMag=s.Mag>99.9
  s.NoS=s.SClass==' '; s.NoL=s.LClass==' '

END FUNCTION ReadTycho2Sp

END MODULE Tycho2Sp
