MODULE LoadSp

USE Tycho2SP

IMPLICIT NONE

TYPE TSpData
 INTEGER(2):: TYC1 !  TYC1 
 INTEGER(2):: TYC2 !  TYC2 
 INTEGER(2):: TYC3 !  TYC3 
 CHARACTER(1) :: TClass !   
 CHARACTER(1) :: SClass !   
 CHARACTER(1) :: LClass !  
END TYPE

TYPE(TSpData), STATIC :: SpData(1:Tycho2SPNumOfStars)
INTEGER(4), STATIC :: Index(1:9537)

CONTAINS

SUBROUTINE LoadSpData
INTEGER(4) :: i,k
LOGICAL :: l
TYPE(TTycho2Sp) :: star
k=0
CALL OpenTycho2Sp
DO i=1,Tycho2SPNumOfStars
 l=ReadTycho2Sp(star)
 SpData(i).TClass=star.TClass
 SpData(i).SClass=star.SClass
 SpData(i).LClass=star.LClass
 SpData(i).TYC1=star.TYC1
 SpData(i).TYC2=star.TYC2
 SpData(i).TYC3=star.TYC3
 IF (star.TYC1>k) THEN
  k=star.TYC1 
  Index(k)=i
 END IF
END DO
CALL CloseTycho2Sp
END SUBROUTINE

LOGICAL FUNCTION FindSpData(T1,T2,T3, TCl,SCl,LCl)
 INTEGER(2),INTENT(IN):: T1,T2,T3
 CHARACTER(1),INTENT(OUT) :: TCl, SCl, LCl
 INTEGER(4) :: i
 FindSpData=.false.
 i=Index(T1);
 DO WHILE (i<Tycho2SPNumOfStars)
  IF (SpData(i).TYC1>T1) EXIT
  IF (SpData(i).TYC2==T2 .and. SpData(i).TYC3==T3) THEN
    TCl=SpData(i).TClass; SCl=SpData(i).SClass; LCl=SpData(i) .LClass
    FindSpData=.true.
    EXIT
  END IF
  I=I+1
 END DO
END FUNCTION FindSpData


END MODULE



