PROGRAM COMPAREDISTANCES
USE HipMain
USE Tycho2
USE PhotoDist
USE LoadSp
USE DFPort

INTEGER(4), PARAMETER :: NHip = 117955; !    
REAL(4), PARAMETER :: RelErr = 0.5;  !     
REAL(4), PARAMETER :: Rmax   = 500.0; !     

TYPE THip
  INTEGER(4) :: Hip !    Hipparcos 
  REAL(4) :: Plx    !    mas 
  REAL(4) :: SPlx   !    mas 
END TYPE

TYPE(THip) HipCat(NHip)

INTEGER(4) :: step   = Tycho2NumOfStars/80

INTEGER(4) :: k
TYPE(TTycho2) :: s
INTEGER(4):: h!     Hipparcos 
REAL(4) :: Mj,BVj !    B-V    
CHARACTER(1) :: TClass,SClass,LClass !   
REAL(4) :: r_px,r_ph !       
INTEGER(4) :: f = 22 !   

 PRINT *,'Load Hipparcos'
 CALL LoadHipparcos 
 PRINT *,'Sort Hipparcos'
 CALL SortHipparcos
 CALL OpenTycho2
 PRINT *,'Load Spectral Data'
 CALL LoadSpData
 
 OPEN(UNIT=f,FILE='r.txt')
 
 DO WHILE (ReadTycho2(s))
 
  k=k+1; IF (MOD(k,step)==0) code=PUTC('*')
  
  !    Hipparcos 
  h=FindHip(s.Hip);
  IF (h==0) CYCLE !    ,    
  IF (HipCat(h).Plx<=0.0) CYCLE ! ""  
  !    
  IF (HipCat(h).sPlx/HipCat(h).Plx>RelErr) CYCLE
  r_px=1000.0/HipCat(h).Plx;
  IF (r_px>RMax) CYCLE
  !     
  IF (s.NoVT .or. s.NoBT) CYCLE
  !    
  IF (.not. FindSpData(s.TYC1,s.TYC2,s.TYC3,TClass,SClass,LClass)) CYCLE
  !    
  Mj =s.VT-0.090*(s.BT-s.VT);  BVj=0.850*(s.BT-s.VT);
  IF (.not. PhotoDistance(TClass,SClass,LClass,Mj,BVj,r_ph)) CYCLE
  IF (r_ph>RMax) CYCLE
  WRITE(f,'(I6,2F8.1)')  HipCat(h).Hip,r_px,r_ph
 END DO

 CLOSE(UNIT=f)


CONTAINS
 
SUBROUTINE LoadHipparcos;
!    Hipparcos   HipCat 
INTEGER(4) :: i 
TYPE(THipparcos)  s
CALL OpenHipparcosMain
i=0
DO WHILE (ReadHipparcosMain(s))
  IF (s.NoPlx) CYCLE
  i=i+1
  HipCat(i).Hip=s.Hip 
  HipCat(i).Plx=s.Plx 
  HipCat(i).SPlx=s.sigma_Plx
END DO
  CALL CloseHipparcosMain
END SUBROUTINE


SUBROUTINE SortHipparcos
!    HipCat 

 LOGICAL Sorted  !  -   
 INTEGER(4) :: l, r, i
 TYPE(THip) t
 
 l=1; r=NHip

 DO WHILE(.not. Sorted)
  
  Sorted=.True. !   

  DO i=l,r-1     !    
   IF (HipCat(i).Hip>HipCat(i+1).Hip) THEN
    t=HipCat(i); HipCat(i)=HipCat(i+1); HipCat(i+1)=t
    Sorted=.False. !   
   END IF
  END DO
  r=r-1

  DO i=r-1,1,-l   !    
   IF (HipCat(i).Hip>HipCat(i+1).Hip) THEN
    t=HipCat(i); HipCat(i)=HipCat(i+1); HipCat(i+1)=t
    Sorted=.False. !   
   END IF
  END DO 
  l=l+1


 END DO

END SUBROUTINE

INTEGER(4) FUNCTION FindHip(Hip0)
!    ,   Hip=Hip0 
 INTEGER(4) :: Hip0
 INTEGER(4) :: l, r, n

 FindHip=0
 l=1; r=NHip
 DO WHILE (L<R)
  n=(l+r)/2
  IF (HipCat(n).Hip==Hip0) THEN
   FindHip=n; 
   EXIT
  END IF 
  IF (HipCat(n).Hip<Hip0) THEN
    l=n+1 
  ELSE
    r=n
  END IF
 END DO
END FUNCTION



END PROGRAM
