Program HipTycho;
Uses HipMain,Tycho2,PhotoDist,LoadSp;

Const NHip = 117955;  {   ࠫᠬ }
      RelErr = 0.5;   { ⨬ ⭮. 訡 ࠫ }
      Rmax   = 500.0; { . ﭨ ᯮ㥬  }

Type  THip = record
               Hip  : longint; {    Hipparcos }
               Plx  : single;  { ࠫ   mas }
               SPlx : single;  { 訡 ࠫ  mas }
              end;

Var HipCat : array [1..NHip] of THip;

Procedure LoadHipparcos;
{ 㧪  ⠫ Hipparcos  ᨢ HipCat }
var i : longint;
    s : THipparcos;
begin
 OpenHipparcosMain;
 i:=0;
 while ReadHipparcosMain(s) do
 begin
  if (s.info and NoPlx) <> 0 then continue;
  inc(i);
  with HipCat[i] do
  begin
   Hip:=s.Hip; Plx:=s.Plx; SPlx:=s.sigma.Plx;
  end;
 end;
 CloseHipparcosMain;
end;


Procedure SortHipparcos;
{ 쪮 ஢ ᨢ HipCat }

 var Sorted : boolean; {  - ᨢ ஢ }

  Procedure InterChange(m,n:longint);
  {  ⠬ m-  n-  HipCat }
  var t : THip;
  begin
   t:=HipCat[m]; HipCat[m]:=HipCat[n]; HipCat[n]:=t;
   Sorted:=False; {  䫠 }
  end;
var l, r, i : longint;

begin
 l:=1; r:=NHip;

 repeat
  Sorted:=True; { ⠭ 䫠 }

  for i:=l to r-1 do    { 室 ᫥ ࠢ }
   if (HipCat[i].Hip>HipCat[i+1].Hip) then InterChange(i,i+1);
  dec(r);

  for i:=r-1 downto l do  { 室 ࠢ  }
   if (HipCat[i].Hip>HipCat[i+1].Hip) then InterChange(i,i+1);
  inc(l);

 until Sorted;

end;

Function FindHip(Hip0:longint):longint;
{    ᨢ,  ஬ Hip=Hip0 }
var l, r, n : longint;
begin
 FindHip:=0;
 l:=1; r:=NHip;
 repeat
  n:=(l+r) div 2;
  if HipCat[n].Hip=Hip0 then begin FindHip:=n; break; end;
  if HipCat[n].Hip<Hip0 then l:=n+1 else r:=n;
 until l>=r;
end;

{  ணࠬ }

Const step  : longint = Tycho2NumOfStars div 80;

var k : longint;
    s : TTycho2;
    h : longint; {   ᨢ  Hipparcos }
    Mj,BVj  : single; {  .  B-V  ⥬ ᮭ }
    TClass,SClass,LClass : char; { ࠫ  }
    r_px,r_ph : single; { ᪮ ﭨ   }
    f : text; {  १⮢ }

begin
 write('Load Hipparcos     ... '); LoadHipparcos; writeln('Ok');
 write('Sort Hipparcos     ... '); SortHipparcos; writeln('Ok');
 OpenTycho2;
 write('Load Spectral Data ... '); LoadSpData; writeln('Ok');
 assign(f,'r.txt'); rewrite(f);
 
 
while ReadTycho2(s) do
 begin
  
  {  ண  80 祪 }
  inc(k); if k mod step = 0 then write('.');
  
  {    Hipparcos }
  if s.Hip=0 then continue else h:=FindHip(s.Hip);
  if h=0 then continue; { ᫨  ,  ய }

  if HipCat[h].Plx<=0.0 then continue; { "宩" ࠫ }

  {  筮 ࠫ }
  if HipCat[h].sPlx/HipCat[h].Plx>RelErr then continue;

  r_px:=1000.0/HipCat[h].Plx; { ᫨ ਣ. ﭨ }

  if r_px>RMax then continue; { 讥 ﭨ ய }

  { ஢ઠ   稭 }
  if ((s.magn and NoVT)<>0) or ((s.magn and NoBT)<>0) 
      then continue;

  {  ᯥࠫ  }
  if not FindSpData(s.TYC1,s.TYC2,s.TYC3,TClass,SClass,LClass)
      then continue;

  { ᫥ ⮬᪮ ﭨ }
  Mj :=s.VT-0.090*(s.BT-s.VT);  BVj:=0.850*(s.BT-s.VT);
  if not PhotoDistance(TClass,SClass,LClass,Mj,BVj,r_ph) 
    then continue;

  { 뢮 १ }
  writeln(f,HipCat[h].Hip:6,r_px:8:1,r_ph:8:1); 

 end; { while }

 close(f);

end.