Unit Tycho2; { ⥭ ⠫ Tycho2 }

Interface { 䥩᭠   }

{ ᯮ  ᨨ ⠫ Tycho2 }
Const Tycho2Name       = 'D:\TYCHO-2\Data\catalog.dat';
      Tycho2NumOfStars =  2539913;
{ ⮢ ⠭ 䫠  ⢨ ⮬ਨ }
Const  NoBT = 1; {     稭 BT }
       NoVT = 2; {     稭 VT }
Type 
 TTycho2=record
  { 䨪 }
  TYC1 : word; { [1..9537] 䨪 }
  TYC2 : word; { [1..12121] 䨪 }
  TYC3 : word; { [1..3] 䨪 }
  { ।   ᮡ⢥   J2000.0 }
  pflag : char;{ [ PX]
                 ' ' - ଠ쭮 ।   ..
                 'P' - ।   .. 業,
                 'X' -  ।   .. }
  mRAdeg, mDEdeg : double; { । RA  DE  J2000.0 }
  pmRA,   pmDE   : double; { । ..  J2000.0 }
  e_mRA,  e_mDE  : single; { 訡 RA  DE  ।.  }
  e_pmRA, e_pmDE : single; { 訡 ᮡ⢥  }
  mepRA,  mepDE  : single; { ।  RA  DE }
  Num            : word;   { ᫮ ᯮ짮  }
  { ਨ ᮣ. ⢨⥫  Num>2! }
  g_mRA,  g_mDE  : single; { ਨ ᮣ । RA  DE } 
  g_pmRA, g_pmDE : single; { ਨ ᮣ ᮡ. . }
  { ⮬᪠ ଠ. ஢ 䫠 magn }
  BT,     e_BT   : single; {  稭 BT  訡 }
  VT,     e_VT   : single; {  稭 VT  訡 }

  prox           : word;   { [3,999]    0.1? }

  { ⥫ 䨪 }
  TYC  : char;      { 稥   Tycho-1 'T'  ' ' }
  HIP  : longint;   {    Hipparcos  0 }
  CCDM : string[3]; { . CCDM   Hipparcos }

  { न ICRS, 祭   }
  RAdeg, DEdeg  : double; { RA  DE 祭  Tycho-2 }
  epRA,  epDE   : single; { -1990.0  RAdeg, DEdeg }
  e_RA,  e_DE   : single; { 訡 RAdeg, DEdeg,  }
  postflg : char;   {  襭  Tycho2: ' ' - ଠ쭮,
                    'D' -  , 'P' - 業 }
  corr    : single; { ५  RAdeg  DEdeg }
  magn    : word;   { ⮢ 䫠 ⢨ BT  VT }

 end { record } ;
  Procedure OpenTycho2;  { ⨥ 䠩 ⠫ }
  Procedure CloseTycho2; { ⨥ 䠩 ⠫ }

  { ⥭  ப ⠫: १ 頥  s,
    頥 false  ⨦  䠩 }
  Function ReadTycho2(var star : TTycho2):boolean;

Implementation { ᯮ⥫쭠   }

var cat : text; {  ६ ⠫ }

 Procedure OpenTycho2;
 begin
  FileMode:=0; { 쪮 ⥭ }
  assign(cat,Tycho2Name); reset(cat);
  position:=0;
 end { OpenTycho2 };

 Procedure CloseTycho2;
 begin
  close(cat);
  position:=-1; { ਧ ⮣ ⠫ }
 end { CloseTycho2 };

 Function ReadTycho2(var star : TTycho2):boolean;
 var t   : string[206]; {   ⥭ ப ⠫ }
     err : integer;    {  訡  ८ࠧ  ᫮ }
 begin
  
{ ᫨ ⨣  䠩,  頥 False }
  if eof(cat) then ReadTycho2:=false else
  begin
   ReadTycho2:=true;
   readln(cat,t); 

   with star do { 樨  ﬨ  star }
   begin

    magn:=0; { 㫥  ⮢ 䫠 }
    
    { 楤 Val ८ࠧ ⥪⮢ ப  ᫮,
      err ⫨砥    砥 訡 ८ࠧ.
      㭪 copy 頥 ப  㪠
      ⮢ 樨  ⢠ ⮢. }
    
    { । 䨪஢ }
    Val(copy(t, 1,4),TYC1,err);
    Val(copy(t, 6,5),TYC2,err);
    Val(copy(t,12,1),TYC3,err);

    
 
    { । ।   ᮡ⢥  }
    pflag:=t[14];
    if pflag<>'X' then
    begin
     { ।  }
     Val(copy(t,16,12),mRAdeg,err);
     Val(copy(t,29,12),mDEdeg,err);
     { ⢥  }
     Val(copy(t,42, 7),pmRA,err);
     Val(copy(t,50, 7),pmDE,err);
     { 訡  }
     Val(copy(t,58, 3),e_mRA,err);
     Val(copy(t,62, 3),e_mDE,err);
     { 訡 ᮡ⢥  }
     Val(copy(t,66, 4),e_pmRA,err);
     Val(copy(t,71, 4),e_pmDE,err);
     { ।  RA  DE }
     Val(copy(t,76, 7),mepRA,err);
     Val(copy(t,84, 7),mepDE,err);
     { ᫮ ᯮ짮  }
     Val(copy(t,92, 2),Num,err);
     
     { ਨ ᮣ }
     if Num>2 then
     begin
      Val(copy(t, 95,3),g_mRA,err);
      Val(copy(t, 99,3),g_mDE,err);
      Val(copy(t,103,3),g_pmRA,err);
      Val(copy(t,107,3),g_pmDE,err);
     end;

    end { if pglag };

    { ⮬ }
    
    {  稭 BT }
    Val(copy(t,111,6),BT,err);
    if err<>0 then Magn:=Magn or NoBT
              else Val(copy(t,118,5),e_BT,err);
    
    {  稭 VT }
    Val(copy(t,124,6),VT,err);
    if err<>0 then Magn:=Magn or NoVT
              else Val(copy(t,131,5),e_VT,err);

        {   }
    Val(copy(t,137,6),prox,err);
    
    { 稥   Tycho-2 }
    TYC:=t[141];

    {    Hipparcos  0 }
    Val(copy(t,143,6),HIP,err);
    if err<>0 then begin HIP:=0; CCDM:=''; end
               else CCDM:=copy(t,149,3);
 
    { RA, DE, 祭  Tycho-2 }
    Val(copy(t,153,12),RAdeg,err);
    Val(copy(t,166,12),DEdeg,err);

    {  RA, DE, 祭  Tycho-2 }
    Val(copy(t,179,4),epRA,err);
    Val(copy(t,184,4),epDE,err);
 
    { 訡 RA, DE, 祭  Tycho-2, ᭮   }
    Val(copy(t,189,5),e_RA,err);
    Val(copy(t,195,5),e_DE,err);
 
    {  襭   Tycho-2 }
    postflg:=t[201];
 
    { ५  RA  DE }
    Val(copy(t,203,4),corr,err);
 
   end { with };

  end { if } ;

 end { ReadTycho2 };

end.
