Unit Tycho2Sp;

{ ⥭ ⠫ Tycho2 Spectral Types }

Interface { 䥩᭠   }

 { ᯮ  ᨨ ⠫ Tycho2 }
 Const Tycho2SPName : string[79] = 'D:\CATALOGS\TYCHO-2 Spectral Types\catalog.dat';
       Tycho2SPNumOfStars = 351863;

 { ⮢ ⠭ 䫠  稨 ଠ樨 }
 Const  NoBT  =  1; {     稭 BT }
        NoVT  =  2; {     稭 VT }
        NoMag =  4; {     稭 Mag }
        NoS   =  8; {    ᯥࠫ쭮  }
        NoL   = 16; {    ᯥࠫ쭮  }

 Type TTycho2SP=record
      { 䨪 }
       TYC1 : word; { 䨪 TYC1 }
       TYC2 : word; { 䨪 TYC2 }
       TYC3 : word; { 䨪 TYC3 }
      { ।   J2000.0 }
       mRAdeg, mDEdeg : double; { । RA  Dec  J2000.0 }
       BT    : single; {  稭 BT }
       VT    : single; {  稭 VT }
       r_SpType : string[3]; { 筨 ᯥࠫ쭮  }
       Name : string[15]; { ⥫쭮 祭  }
       Dist : single; { ﭨ  ꥪ⮬ Tycho-2  ꥪ⮬
                         ⠫ ᯥࠫ쭮  }
       Mag  : single; {  稭  ⠫ ᯥࠫ쭮  }
       f_Mag : char;  {   稭 [VPBX*] }
       TClass : char; {   }
       SClass : char; {   }
       LClass : char; {  ᢥ⨬ }
       Teff   : longint; { 䥪⨢ ⥬ }
       SpType : string[20]; { ⮥ 祭 ᯥࠫ쭮  }
       info  : word;   { ⮢ 䫠 ᢨ ଠ樨 }
      end;

  Procedure OpenTycho2Sp;  { ⨥ 䠩 ⠫ }
  Procedure CloseTycho2Sp; { ⨥ 䠩 ⠫ }

  { ⥭  窨 ⠫:
     頥  star,
    頥 false  ⨦  䠩 }
  Function ReadTycho2Sp(var star : TTycho2Sp):boolean;

Implementation { ᯮ⥫쭠   }

 var   f      : text;         {  ६ ⠫ }

 Procedure OpenTycho2Sp;
 begin
  FileMode:=0; { 쪮 ⥭ }
  assign(f,Tycho2SpName); reset(f);
 end { OpenTycho2Sp };

 Procedure CloseTycho2Sp;
 begin
  close(f);
 end { CloseTycho2Sp };

 Function ReadTycho2Sp(var star : TTycho2Sp):boolean;
 var t   : string[124]; {   ⥭ ப ⠫ }
     err : integer;     {  訡  ८ࠧ  ᫮ }
 begin
  { ᫨ ⨣  䠩  頥 False }
  if eof(f) then ReadTycho2Sp:=false else
  begin
   ReadTycho2Sp:=True;
   readln(f,t);

   with star do { 樨  ﬨ  s }
   begin

    info:=0; { 㫥  ⮢ 䫠 }

    { + 楤 Val ८ࠧ ⥪⮢ ப  ᫮,
        err ⫨砥    砥 訡 ८ࠧ.
      + 㭪 Copy 頥 ப  㪠
        ⮢ 樨  ⢠ . }

    { । 䨪஢ }
    Val(copy(t, 5,4),TYC1,err);
    Val(copy(t,10,5),TYC2,err);
    Val(copy(t,16,1),TYC3,err);

    { । ।   .. }
     Val(copy(t,18,12),mRAdeg,err);
     Val(copy(t,31,12),mDEdeg,err);

    {  稭 VT }
    Val(copy(t,44,6),VT,err);
    if VT>99.9 then Info:=Info or NoVT;

    {  稭 BT }
    Val(copy(t,51,6),BT,err);
    if BT>99.9 then Info:=Info or NoBT;

    { 筨 ᯥࠫ쭮  }
    r_SpType:=copy(t,58,3);

    { ⥫쭮   }
    Name:=copy(t,62,15);

    { ﭨ  ꥪ⮬ Tycho-2  ꥪ⮬  ⠫ .  }
    Val(copy(t,78,6),Dist,err);

    {  稭 Mag }
    Val(copy(t,85,6),Mag,err);
    if Mag>99.9 then Info:=Info or NoMag;

    {   稭 }
    f_Mag:=t[92];

    {   }
    TClass:=t[94];

    {   }
    SClass:=t[95]; if SCLass=' ' then Info:=Info or NoS;

    {  ᢥ⨬ }
    LClass:=t[97]; if LCLass=' ' then Info:=Info or NoL;

    { 䥪⨢ ⥬ }
    Val(copy(t,99,5),Teff,err);

    { ࠫ  }
    SpType:=copy(t,105,20);

   end { with };

  end {if } ;
 end { ReadTycho2Sp };

end.
